/* Generated by re2c 3.1 on Fri Jan 17 22:04:36 2025 */
#line 1 "TRConfigLexer.re"
/*
 * TRConfigLexer.re vi:ts=4:sw=4:expandtab:
 * Configuration Lexer
 *
 * Author: Landon Fuller <landonf@threerings.net>
 *
 * Copyright (c) 2006 - 2007 Three Rings Design, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of any contributors
 *    may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifdef HAVE_CONFIG_H
#import <config.h>
#endif

#import <stdio.h>
#import <assert.h>
#import <sys/types.h>
#import <sys/stat.h>
#import <sys/mman.h>

#import "TRConfig.h"
#import "TRConfigLexer.h"
#import "TRConfigParser.h"

/*
 * re2c Configuration
 */
#define YYCTYPE     char        /* Input Symbol Type */
#define YYCURSOR    _cursor     /* L-expression of type *YYCTYPE that points to the current input symbol */
#define YYLIMIT     _limit      /* Expression of type *YYCTYPE that marks the end of the buffer */
#define YYMARKER    _marker     /* L-expression of type *YYCTYPE that is used for backtracking information */
#define YYCTXMARKER _ctxMarker  /* L-expression of type *YYCTYPE that is used for trailing context back tracking information */
#define YYFILL(n)   [self fill: n]  /* YYFILL(n) is called when the buffer needs (re)filling */

#define YYDEBUG(state, current) printf("state: %d, current: '%c' (%d)\n", state, current, current);

/*
 * Macros
 */

/* Increment line count */
#define INCR_LINE()    _lineNumber++

/* Switch to a start condition */
#define BEGIN(cond)    ( _condition = LEXER_SC_ ## cond)

/* Declare a start condition */
#define SC(cond)    LEXER_SC_ ## cond: LEXER_SC_ ## cond

/* Check for end-of-input */
#define CHECK_EOI()    if (_eoi) { return NULL; }

/* Skip a token */
#define SKIP(cond)    CHECK_EOI(); goto LEXER_SC_ ## cond

/* Get the current token length */
#define TOKEN_LENGTH()    (_cursor - _token)

@implementation TRConfigLexer

- (void) dealloc {
    if (buffer)
        munmap(buffer, bufferLength);
    [super dealloc];
}

- (id) initWithFD: (int) fd {
    struct stat statbuf;

    /* Initialize */
    self = [self init];
    if (self == NULL)
        return (self);

    /* Mmap() source file
     * Unless our caller botched something, this should never fail */
    assert((fstat(fd, &statbuf) == 0));
    bufferLength = statbuf.st_size;
    buffer = mmap(NULL, bufferLength, PROT_READ, MAP_SHARED, fd, 0);
    assert(buffer != MAP_FAILED);

    /* Initialize lexer state */
    _lineNumber = 1;
    _condition = LEXER_SC_INITIAL;
    _cursor = buffer;
    _limit = _cursor + bufferLength - 1;

    return (self);
}

- (void) fill: (int) length {
    /* We just need to prevent re2c from walking off the end of our buffer */
    assert(_limit - _cursor >= 0);
    if (_cursor == _limit) {
        /* Save the cursor and signal EOI */
        _eoi = _cursor;
    }
}

- (TRConfigToken *) scan {
    TRConfigToken *token;
    #line 129 "TRConfigLexer.re"


    /* Test for EOI before scanning */
    CHECK_EOI();

    switch (_condition) {
        case SC(INITIAL):
            _token = _cursor;
            
#line 139 "TRConfigLexer.m"
{
	YYCTYPE yych;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '\t':
		case ' ': goto yy2;
		case '\n': goto yy4;
		case '#': goto yy5;
		case '-':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z': goto yy7;
		case '<': goto yy9;
		default: goto yy1;
	}
yy1:
	++YYCURSOR;
#line 171 "TRConfigLexer.re"
	{
                // TODO explode here
                printf("Unknown character: '%c' (%d)\n", yych, yych);
                return NULL;
            }
#line 224 "TRConfigLexer.m"
yy2:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '\t':
		case ' ': goto yy2;
		default: goto yy3;
	}
yy3:
#line 140 "TRConfigLexer.re"
	{
                SKIP(INITIAL);
            }
#line 239 "TRConfigLexer.m"
yy4:
	++YYCURSOR;
#line 165 "TRConfigLexer.re"
	{
                INCR_LINE();
                SKIP(INITIAL);
            }
#line 247 "TRConfigLexer.m"
yy5:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '\n': goto yy6;
		default: goto yy5;
	}
yy6:
#line 145 "TRConfigLexer.re"
	{
                SKIP(INITIAL);
            }
#line 261 "TRConfigLexer.m"
yy7:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '-':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z': goto yy7;
		default: goto yy8;
	}
yy8:
#line 150 "TRConfigLexer.re"
	{
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH()
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_KEY];
                BEGIN(VALUE);
                return token;
            }
#line 343 "TRConfigLexer.m"
yy9:
	++YYCURSOR;
#line 160 "TRConfigLexer.re"
	{
                SKIP(SECTION);
            }
#line 350 "TRConfigLexer.m"
}
#line 177 "TRConfigLexer.re"


            break;

        /* Section Declarations */
        case SC(SECTION):
            _token = _cursor;
            
#line 361 "TRConfigLexer.m"
{
	YYCTYPE yych;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	switch (yych) {
		case '\n': goto yy12;
		case '-':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z': goto yy13;
		case '/': goto yy14;
		default: goto yy11;
	}
yy11:
yy12:
	++YYCURSOR;
#line 217 "TRConfigLexer.re"
	{
                INCR_LINE();
                SKIP(INITIAL);
            }
#line 443 "TRConfigLexer.m"
yy13:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '\t':
		case ' ':
			YYCTXMARKER = YYCURSOR;
			goto yy15;
		case '-':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z': goto yy13;
		case '>': goto yy17;
		default: goto yy11;
	}
yy14:
	yych = *++YYCURSOR;
	switch (yych) {
		case '>': goto yy11;
		default: goto yy19;
	}
yy15:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '\t':
		case ' ': goto yy15;
		default: goto yy16;
	}
yy16:
	YYCURSOR = YYCTXMARKER;
#line 197 "TRConfigLexer.re"
	{
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH()
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_SECTION_START];
                BEGIN(SECTION_NAME);
                return token;
            }
#line 546 "TRConfigLexer.m"
yy17:
	++YYCURSOR;
#line 187 "TRConfigLexer.re"
	{
                /* Drop the trailing ">" */
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH() - 1
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_SECTION_START];
                return token;
            }
#line 558 "TRConfigLexer.m"
yy18:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy19:
	switch (yych) {
		case '-':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z': goto yy18;
		case '>': goto yy20;
		default: goto yy11;
	}
yy20:
	++YYCURSOR;
#line 207 "TRConfigLexer.re"
	{
                /* Drop the leading '/' and trailing ">" */
                token = [[TRConfigToken alloc] initWithBytes: _token + 1
                                    numBytes: TOKEN_LENGTH() - 2
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_SECTION_END];
                return token;
            }
#line 643 "TRConfigLexer.m"
}
#line 222 "TRConfigLexer.re"


            break;

        case SC(SECTION_NAME):
            _token = _cursor;
            
#line 653 "TRConfigLexer.m"
{
	YYCTYPE yych;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '\t':
		case ' ': goto yy23;
		case '\n': goto yy25;
		case '-':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z': goto yy26;
		default: goto yy22;
	}
yy22:
yy23:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '\t':
		case ' ': goto yy23;
		default: goto yy24;
	}
yy24:
#line 230 "TRConfigLexer.re"
	{
                SKIP(SECTION_NAME);
            }
#line 743 "TRConfigLexer.m"
yy25:
	++YYCURSOR;
#line 246 "TRConfigLexer.re"
	{
                INCR_LINE();
                SKIP(INITIAL);
            }
#line 751 "TRConfigLexer.m"
yy26:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '-':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'S':
		case 'T':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case '_':
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z': goto yy26;
		case '>': goto yy27;
		default: goto yy22;
	}
yy27:
	++YYCURSOR;
#line 235 "TRConfigLexer.re"
	{
                /* Drop the trailing ">" */
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH() - 1
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_SECTION_NAME];
                BEGIN(INITIAL);
                return token;
            }
#line 836 "TRConfigLexer.m"
}
#line 251 "TRConfigLexer.re"


        /* Values */
        case SC(VALUE):
            _token = _cursor;
            
#line 845 "TRConfigLexer.m"
{
	YYCTYPE yych;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '\t':
		case ' ': goto yy31;
		case '\n': goto yy33;
		case '"': goto yy34;
		case '#': goto yy35;
		default: goto yy29;
	}
yy29:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '\t':
		case '\n':
		case ' ':
		case '"': goto yy30;
		default: goto yy29;
	}
yy30:
#line 272 "TRConfigLexer.re"
	{ /* " vim syntax fix */
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH()
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_VALUE];
                return token;
            }
#line 878 "TRConfigLexer.m"
yy31:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '\t':
		case ' ': goto yy31;
		default: goto yy32;
	}
yy32:
#line 257 "TRConfigLexer.re"
	{
                SKIP(VALUE);
            }
#line 893 "TRConfigLexer.m"
yy33:
	++YYCURSOR;
#line 281 "TRConfigLexer.re"
	{
                INCR_LINE();
                SKIP(INITIAL);
            }
#line 901 "TRConfigLexer.m"
yy34:
	++YYCURSOR;
#line 267 "TRConfigLexer.re"
	{
                SKIP(STRING_VALUE);
            }
#line 908 "TRConfigLexer.m"
yy35:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '\n': goto yy36;
		default: goto yy35;
	}
yy36:
#line 262 "TRConfigLexer.re"
	{
                SKIP(VALUE);
            }
#line 922 "TRConfigLexer.m"
}
#line 286 "TRConfigLexer.re"

            break;

        /* Quoted string values */
        case SC(STRING_VALUE):
            _token = _cursor;

            
#line 933 "TRConfigLexer.m"
{
	YYCTYPE yych;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '"': goto yy38;
		case '#': goto yy40;
		default: goto yy39;
	}
yy38:
yy39:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '"': goto yy41;
		default: goto yy39;
	}
yy40:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '\n': goto yy39;
		case '"': goto yy42;
		default: goto yy40;
	}
yy41:
	++YYCURSOR;
#line 302 "TRConfigLexer.re"
	{
                /* Skip the trailing '"' */
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH() - 1
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_VALUE];
                return token;
            }
#line 972 "TRConfigLexer.m"
yy42:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
		case '\n': goto yy43;
		default: goto yy42;
	}
yy43:
#line 296 "TRConfigLexer.re"
	{
                SKIP(STRING_VALUE);
            }
#line 986 "TRConfigLexer.m"
}
#line 317 "TRConfigLexer.re"

            break;

        default:
            /* Impossible */
            assert(0);
    }

    /* Never reached */
    return nil;
}

@end
